/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package metier;

import java.util.ArrayList;
import java.util.Vector;

/**
 *
 * @author emile.lalorcey
 */
public class Jeu {
    String nomJeu = "Jeu de Role" ;
    private ArrayList<Personnage> mesPersonnages;
    
    /********* Constructeurs ********/
    
    /**
    * Constructeur de Jeu
    */ 
    public Jeu(){
        this.chargerLesPersonnages();
        }
    
    /********* Guetteur ********/
    public String getnomJeu(){
        return this.nomJeu;
    }
    
    /**
     * Getteur de mes personnages
     * @return  mes personnages
     */
    public ArrayList<Personnage> getmesPersonnages(){
        return mesPersonnages;
    }
    
    /********* Setteurs ********/
    
        
    /********* Fonctions ********/
    
    /**
     * Crée les personnages
     */
    private void chargerLesPersonnages(){
        mesPersonnages = new ArrayList<Personnage>();
        mesPersonnages.add(new Guerrier("Barbare", "", 6, 4, "Hache"));  
        mesPersonnages.add(new Guerrier("Garren","Guerrier08.jpg" , 2, 8, "Gourdin"));
        mesPersonnages.add(new Guerrier("Hellen","Guerrier08.jpg" , 8, 6, "Gourdin"));
        //mesPersonnages.add(new Personnage("Gaelle", "Barbare04.jpg", 5, 3)); 
        //Plus possible car personnage est devenue abstract
        mesPersonnages.add(new Voleur("Raptout", "", 2, 4, "Marteau"));
        mesPersonnages.add(new Sorcier("Panoramix", "", 10, 5, "Baguette de laurier"));
        mesPersonnages.add(new Sorcier("Jinx","Barbare04.jpg",0,0, "Bâton"));
        mesPersonnages.add(new FeeSombre("Yokai","Barbare04.jpg",4,6, "Terre"));
        mesPersonnages.add(new FeeSombre("Shard","Barbare04.jpg",7,5, "Vent"));
    }
    
    /**
     * Cette méthode sert à affiché les différents personnages avec leurs affectations
     * @return String tout les personnages avec leurs capacités
     */
    @Override
    public String toString(){
        String mesPersos = "";
        for (int i = 0; i < mesPersonnages.size(); i++){
            mesPersos += mesPersonnages.get(i) + "\n" + "\n";
        }
        return mesPersos;
    }
     
    /**
     * recherche un personnage
     * @param n un entier
     * @return le personnage recherchés
     */
    public Personnage rechercherPerso(String n){
        int indice = 0;
        boolean trouver = false;
        while(indice < this.mesPersonnages.size() && !trouver){
            trouver = (this.mesPersonnages.get(indice).getNom().equals(n));
            indice++;
        }
        if(trouver){
            indice--;
            return this.mesPersonnages.get(indice);
        }
        return null;
    }
    
    /**
     * Cette fonction génère un nombre aléatoire
     * @param min minimum possible pour le nombre
     * @param max maximum possible pour le nombre
     * @return le nombre aléatoire
     */
    public static int genererNbAleatoire(int min, int max) {
        return min + (int)(Math.random() * ((max - min) + 1));
    }
    
    /**
     * Cette Fonction permet d'obtenir la liste des personnages encore en vie
     * @return 
     */
    public Vector getLesPersonnagesVivants (){
        Vector<String> LesPersonnagesVivants = new Vector<>();
        for(Personnage Perso:mesPersonnages){
            if(Perso.getDureeVie() > 0){
                LesPersonnagesVivants.add(Perso.getClass().getSimpleName()+":"+ Perso.getNom());
            }
        }
        return LesPersonnagesVivants;
    }
    
    
    
}
